// Header File
// Created 8/4/2004; 9:34:55 AM
#ifndef DEFS
#define DEFS
	#define MIN_AMS 200
	#include <tigcclib.h>
	//#define SMALL
	//#define USE_VTI  // difine if you are going to run it on vti
	#define VERTION_STR "1.08"
	#define B_SPEED 7
	#define P_SPEED 7
	#define X_START 75
	#define Y_START 85
	#define MIN_X 0
	#define MAX_X 144
	#define MIN_Y  60
	#define MAX_Y  PSEUDO_CONST_SCREEN(87,114)
	#define MIN_XP 0
	#define MAX_XP 150
	#define MIN_YP 0
	#define MAX_YP PSEUDO_CONST_SCREEN(88,115)
	#define BRICK_X k*17+3
	#define BRICK_Y j*5
	#define SC_ADD 10+vars.psc+vars.ts
	#if defined(USE_TI89) && !(defined(USE_TI92PLUS) || defined(USE_V200))
		#define SHOTS 10
	#else
		#define SHOTS 12
	#endif
	#define redrawStat(stat) (memset(LCD_MEM+PSEUDO_CONST_SCREEN(2790,120*30),0,260),drawStat(stat))
	#ifdef USE_VTI  //if using vti then change idle loop
		#define delay() for(t=0;t<2000;t++);
		#warning "Creating VTI version"
	#else
		#define delay() (pokeIO(0x600005,0b11101),pokeIO(0x600005,0b11101))
	#endif
	#define KEY(key89,key92plus,keyv200) (CALCULATOR?((CALCULATOR==1)?(key92plus):(keyv200)):(key89))

	#define P_UP		RR_UP			//up arrow
	#define P_DOWN	RR_DOWN		//down arrow
	#define P_RIGHT	RR_RIGHT	//right arrow
	#define P_LEFT	RR_LEFT		//left arrow
	#define SHOOT		0,KEY(4,3,3) //shoot key 2ND on 89 hand otherwise
	#define PAUSE		KEY(0,6,6),KEY(5,4,4)
	#define TEACH		KEY(2,7,7),KEY(7,4,4)
	#define QUIT 		RR_ESC

	extern void Mmenu;
	extern unsigned char st[2][5];
	extern unsigned char pwu[7][8];
	extern unsigned char ball[4];
	extern unsigned char msk[4];
	extern unsigned short brick[5][4];
	extern const char *(keys89[9][2]);
	extern const char *(keys92plus[9][2]);
	extern const char *pwrUp[7];

	typedef struct{
		unsigned short ll;
		unsigned char bricks[9][10];
		char nlevel[9];
	}LEVEL;

	typedef struct {
		int x,y;
		short state;
	}LASER;

	typedef struct{
		int xp;
		int yp;
		int xa;
		int ya;
		int x;
		int y;
		int remain;
		int lvs;
		int px;
		int py;
		int psc;
		int lvls;
		unsigned int score;
		int ts;
		int pwrup;
		int ebs;
		int shoot;
		char scl[11];
		char level[9];
		char folder[9];
		HSym lset;//not actually a HSym for a vaable but I neded a hadle and an offset whitch is what it is
		unsigned short lft;
		unsigned short sd;
		unsigned short ct;
		LASER shots[SHOTS];
	}GAME;

	typedef struct{
	unsigned short scores[10];
	char names[10][10];
	char levels[10][9];
	unsigned short lnum[10];
	}HIGH_SCORES;
#endif
